# Get Stakes for a Wallet

Given a wallet address, you can easily find out how much Sol has been staked to which voter/validator.

Here's a code snippet which you can directly run in <mark style="color:yellow;">replit</mark> to see it in action.

{% tabs %}
{% tab title="Code" %}

```javascript

const SHYFT_KEY = "YOUR-KEY"

async function fetchGraphQL(query, name, variables) {
  const result = await fetch(
    `https://programs.shyft.to/v0/graphql/?api_key=${SHYFT_KEY}`,
    {
      method: "POST",
      body: JSON.stringify({
        query: query,
        variables: variables,
        operationName: name
      })
    }
  );

  return await result.json();
}

async function fetchStakes(wallet:string) {

const query = `
  query StakesQuery($_contains: jsonb = "") {
    Stake_Program_Stake(where: {meta: {_contains: $_contains}}) {
      _lamports
      meta
      stake
      pubkey
    }
  }
`;

  const variables = {
    _contains: {
      authorized: {
        staker: "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM"
      }
    }
  }

  const { errors, data } = await fetchGraphQL(
    query,
    "StakesQuery",
    variables
  );

  if (errors) {
    // handle those errors like a pro
    console.error(errors);
  }

  // do something great with this precious data
  console.log(data);
}

fetchStakes("9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM");
```

{% endtab %}

{% tab title="Response" %}

```
{
  "data": {
    "Stake_Program_Stake": [
      {
        "_lamports": 60000002282880,
        "_updatedAt": "2024-03-30T06:01:06.968",
        "meta": {
          "lockup": {
            "epoch": "0",
            "custodian": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM",
            "unix_timestamp": "0"
          },
          "authorized": {
            "staker": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM",
            "withdrawer": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM"
          },
          "rentExemptReserve": "2282880"
        },
        "stake": {
          "delegation": {
            "stake": "60000000000000",
            "voter": "3N7s9zXMZ4QqvHQR15t5GNHyqc89KduzMP7423eWiD5g",
            "activationEpoch": "254",
            "deactivationEpoch": "595",
            "warmupCooldownRate": 0.25
          },
          "creditsObserved": "132544279"
        }
      },
      {
        "_lamports": 2282881,
        "_updatedAt": "2024-03-29T11:40:21.695",
        "meta": {
          "lockup": {
            "epoch": "0",
            "custodian": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM",
            "unix_timestamp": "0"
          },
          "authorized": {
            "staker": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM",
            "withdrawer": "9WzDXwBbmkg8ZTbNMqUxvQRAyrZzDsGYdLVL9zYtAWWM"
          },
          "rentExemptReserve": "2282880"
        },
        "stake": {
          "delegation": {
            "stake": "49999997717120",
            "voter": "3N7s9zXMZ4QqvHQR15t5GNHyqc89KduzMP7423eWiD5g",
            "activationEpoch": "254",
            "deactivationEpoch": "273",
            "warmupCooldownRate": 0.25
          },
          "creditsObserved": "9566403"
        }
      },
      
      // More responses in array
    ]
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.shyft.to/solana-indexers/case-studies/solana-native-staking/get-stakes-for-a-wallet.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
